' 12Sep07       Copyright 2007 Raymond Allen

'This is a basic windowing/form showing framework and demo
'it is based on the vga tile driver demo at 1024x768
'uses only 2 cogs for vga because hand drawing cursor
'uses another 2 cogs to do keyboard and mouse

'uses one 16x16x4 color custom character to do the background 

CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  cols = 64        'characters are 16 pixels wide
  rows = 48        '           and 32 pixels tall   (2 16-pixel rows per character)
  tiles = cols * rows


  display_base = $6000

  'number of custom characters              
  nuchars = 1 
  

OBJ

  vga     : "VGA_1024x768_Tile_Driver_With_Cursor"
  mouse   : "mouse"
  num     : "numbers"
  kb      : "Keyboard"
  monitor: "PropMonitor1a"   

  
VAR

  long  col, row, color
  long  boxcolor, boxptr

  long  array[tiles/2]
  long  cursor[1+32]

  long  cursor_x, cursor_y, cursor_col, cursor_def

  word pMessageForm  'pointer to form that called message box

  
  'for custom characters
  word  user_charbase

  word spacetile '= $8000 + $20 << 6

  byte fTop,fLeft,fHeight,fWidth     'form position
  byte oTop,oLeft,oHeight,oWidth,oColor,oType         'object position
  word fStr      'form title string
  byte fObjects  'number of form objects
  byte fTitleColor     'form title color  (always 0)
  byte fBorderColor     'form border color  (always 14)
  byte fTextColor  'color of body text      (always 1)
  byte fDefaultButton 'index of default control (or zero for none)
  word fPointer  'pointer to current form


  

PUB start | i, j, k, l, m

  'start PropMonitor
  monitor.startX(@array,@vgacolors,30)  'Monitor XGA screen using pin 30  

  'init keyboard
  kb.start(26, 27)
  
  'start mouse and set bound parameters
  mouse.start(24, 25)          'use pins 24 and 25
  mouse.bound_limits(0, 0, 0, 63, 47, 0)' 1023, 767, 0)
  mouse.bound_scales(4, -4, 0)
  mouse.bound_preset(1,1,0)' (512, 384, 0)

  'start vga tile driver
  vga.start(16, @array, @vgacolors, 0,0,0) '@cursor_x, 0, 0)

  '64 byte align the user characters
  user_charbase := @uchar & $FFC0 'destination
  longmove(user_charbase,@uchar,16*nuchars)

  spacetile:=user_charbase +15    'using the first user defined character to be the background   with color #15


  'make a darkened/shadowed copy of first 16 colors
  repeat i from 0 to 15
    color:=vgacolors[i] 'the actual color
    j:=color&$AAAAAAAA  '2's
    k:=color&$55555555  '1's
    l:=j&(k<<1)
    k^=$55555555  'invert 1's
    m:=((j>>1)&k)
    color:=l|m
    vgacolors[16+i]:=color                                                          
  'make an inversed/jumbled/darkened copy of first 32 colors
  repeat i from 0 to 31
    color:=vgacolors[i] 'the actual color
    color^=$FFFFFFFF  'invert color
    'flip g&b
    j:=color&$C0C0C0C0  'red
    k:=color&$30303030  'green
    m:=color&$0C0C0C0C  'blue
    color:=j|(k>>2)|(m<<2)'(j>>4)|k|(m<<4)
    color&=$AAAAAAAA  '2's only (darkens some colors)
    vgacolors[32+i]:=color 

  'Set initial form
  showForm(@form1)



    
  'Main Loop:  Display current Form then Show mouse position until button clicked
  repeat 
    kb.clearkeys           'clear keyboard buffer (only accept keys while waiting on mouse down)
    WaitMouseDown          'wait for user to push mouse down
    HandleMouseDown
    WaitMouseUp            'then wait for user to let mouse go
    HandleMouseUp

PRI showForm(pForm)
  pMessageForm:=0  'this is used when displaying a messagebox
  print($100) 'clear the screen 
  InitForm(pForm)
  DrawForm
    
PRI WaitMouseDown   
        'update mouse until click-down
        repeat until mouse.button(0)  'until left-button down
          UpdateMouse
          'check keyboard
          if (kb.gotkey)
            HandleKey 


PRI HandleKey|pObject,key,i,iHot,cHot,bShift
  'user pressed a key, see what to do
  key:=kb.getkey
  bShift:=key&$100
  key&=$FF 'strip flags
  'turn lower case letters to uppper case
  case key
    $61..$7A:
      key-=$20
    $C1,$C3:  'right and down arrows act like tab with no shift
      key:=$09
      bShift:=false
    $C0,$C2:  'left and up arrows act like tabe with shift
      key:=$09
      bShift:=true  
  case key 
    $09:  'tab
      if (fDefaultButton) 
        'some control already defaulted, need to redraw it
        i:=fDefaultButton~
        pObject:= @@(word[fPointer+9+i*2])
        drawObject(pObject)
      else
        i:=0
      'now, find next object in list
      repeat until (fDefaultButton<>0)    'find some control to be default (forms must have a defaultable control!)    
          if bShift
            i--
          else
            i++                    
          if (i>fObjects)
            i:=1
          if (i<1)
            i:=fObjects
          pObject:=@@(word[fPointer+9+i*2])
          case byte[pObject]
            1,4,5:
              fDefaultButton:=i                                                           '4,5         
        
        'draw newly selected object
        'pObject:= @@(word[fPointer+9+fDefaultButton*2])
        drawObject(pObject)                                                                             
    $0D:  'Enter
      i:=fDefaultButton
      pObject:= @@(word[fPointer+9+i*2])
      OnLeftButtonDownOver(pObject,true)
      waitcnt(cnt+5_000_000)  'wait a moment
      OnLeftButtonUp(pObject)   
    $21..$5A:  'normalish character --> Check to see if hotkey
      'iterate objects looking for matching hotkey
      repeat i from 1 to fObjects
        pObject:= @@(word[fPointer+9+i*2])
        oType:=byte [pObject]
        cHot:=0
        case oType
          1:  'button
            iHot:=byte [pObject+5] 'hotkey index
            cHot:=byte[pObject+8+iHot-1]  'hotkey character
          4:
            iHot:=byte [pObject+8] 'hotkey index
            cHot:=byte[pObject+10+iHot-1]  
          5:  'option or check
            iHot:=byte [pObject+8] 'hotkey index
            cHot:=byte[pObject+9+iHot-1] 
        if (cHot==key)
          OnLeftButtonUp(pObject)    'execute command
          quit   'there can be only one...

            
PRI WaitMouseUP
        repeat until !mouse.button(0)     'wait until left button released  
          UpdateMouse
          HandleMouseMoveDown

PRI UpdateMouse          
               'update mouse position
          'first see if mouse has moved
          if ((cursor_x <> mouse.bound_x)|(cursor_y <> mouse.bound_y))
            'mouse did move so reset color of previous spot
            drawMouse(false)
            cursor_x := mouse.bound_x
            cursor_y := mouse.bound_y
            drawMouse(true)




PRI drawMouse(bInvert)
         Invert(cursor_x,cursor_y,bInvert)
         Invert(cursor_x,cursor_y+1,bInvert) 




PRI Invert(x,y,bInvert)|i,j,k
  'invert colors at given location
  i:=array.word[y * cols + x]
  k:=i&$003F  'color index
  if (bInvert) AND (k<32)
    k+=32
  if (!bInvert) AND (k>31)
    k-=32    
  j:=((i>>6)<<6)+k
  array.word[y * cols + x]:=j
    
PRI HandleMouseDown

PRI HandleMouseMoveDown|pObject
   'mouse is in the down position (highlight object that mouse is over)
  pObject:=GetMouseObject
  if pObject==0  'nothing 
    return

  if pObject==fPointer
    DragForm
    return  'just  on form
  'some object drawn different when mouse is down on them
  OnLeftButtonDownOver(pObject,true)
  'wait until mouse moves off object
  repeat until (!mouse.button(0)) OR (GetMouseObject<>pObject)     'wait until left button released or moves off object  
    UpdateMouse
  'redraw object  
  OnLeftButtonDownOver(pObject,false)   
    

PRI DragForm|x,y
  'let the user move the form around with the mouse if on title
  x:=cursor_x
  y:=cursor_y
  if (x<fLeft) OR (x>(fLeft+fWidth)) OR (y<fTop) OR (y>(fTop+1))
    return   'click off form
  highlightForm(true)

  if (pMessageForm<>0)  'this is a messagebox  
    highlightForm(false)  'can't move a messagebox!
    return
   
  repeat until (!mouse.button(0))     'wait until left button released  
    'UpdateMouse
    if (cursor_x<>mouse.bound_x) OR (cursor_y<>mouse.bound_y)
      UpdateMouse
      'give form new postion
      highlightForm(false)
      fTop:=(fTop+mouse.bound_y-y)  #>0
      fTop <#= (47-fHeight-1)
      fLeft:=(fLeft+mouse.bound_x-x) #>0
      fLeft <#= (63-fWidth-1)
      highlightForm(true)
      x:=cursor_x 'mouse.bound_x
      y:=cursor_y 'mouse.bound_y

  'store new position
  byte [fPointer+0]:=fTop
  byte[fPointer+1]:=fLeft
  byte[fPointer+2]:=fHeight  
  byte[fPointer+3]:=fWidth
  'and redraw form
  print($100) 'clear the screen
  drawForm 

PRI highlightForm(b)|i,j
  'indicate the form is being moved
  repeat i from fLeft to fLeft+fWidth-1
    Invert(i,fTop,b)
    Invert(i,fTop+1,b)
    Invert(i,fTop+fHeight-1,b)
  repeat i from fTop+2 to fTop+fHeight-1
    Invert(fLeft,i,b)
    Invert(fLeft+fWidth-1,i,b)

PRI OnLeftButtonDownOver(pObject,bDown)|i
    oTop:= fTop+byte[pObject+1]
    oLeft:=fLeft+byte[pObject+2]
    oHeight:=byte[pObject+3]
    oWidth:= byte[pObject+4]
    oColor:= byte[pObject+5]
    oType:=byte [pObject]
    'see if this object is the default

    case oType
      1:  'button
        'get object index
        repeat i from 1 to fObjects
          if (@@(word[fPointer+9+i*2])==pObject)
            quit
        highlightButton(bDown,(i==fDefaultButton))
      4, 5:  'option or check button
        highlightOption(bDown)  

PRI highlightButton(bDown,bDefault)|clr
  clr:=10'oColor
  if bDown
    clr++
  if bDefault
    clr+=2  
  boxBorder(oTop, oLeft, oHeight, oWidth, clr)
  drawMouse(true)

PRI highlightOption(bDown)|i
  repeat i from oLeft to oLeft+2
    Invert(i,oTop,bDown)
    Invert(i,oTop+1,bDown)
    


PRI HandleMouseUp|pObject 'x,y,i,t,l,h,w,pObject
  'user just released the left mouse button, see if that does anything...
  pObject:=GetMouseObject
  if pObject==0  'nothing clicked on
    return
  if pObject==fPointer'pForm
    highlightForm(true)     'flicker the form
    highlightForm(false)
    return  'just clicked on form
  OnLeftButtonUp(pObject)
  


PRI GetMouseObject:pOb | x,y,i,t,l,h,w,pObject
  x:=mouse.bound_x
  y:=mouse.bound_y
  if (x<fLeft)|(x>(fLeft+fWidth))|(y<fTop)|(y>(fTop+fHeight))
    return 0  'click off form

  'see if any objects clicked on
  repeat i from 1 to fObjects
    pObject:= @@(word[fPointer+8+i*2])
    t:=fTop+byte[pObject+1]
    l:=fLeft+byte[pObject+2]
    h:=byte[pObject+3]
    w:=byte[pObject+4]
    if ((x=>l)&(x=<(l+w-1))&(y=>t)&(y=<(t+h-1)))
      return pObject
  return fPointer'pForm    
      



  
PRI OnLeftButtonUp(pOb)|type,event,group,str,i
  type:=byte[pOb]
  event:=byte[pOb+6]
  CASE event
    0: 'none
      return  'no handler for this event
    1: 'this is button 1 (run menu button)
      if (byte[@frmOption1+7])   'check option #1's value...
        MessageBox(string("Message Box"),string("Option #1"))
      else
        MessageBox(string("Message Box"),string("Option #2"))
    2: 'this is the MessageBox "OK" button event
      'restore the previous form
      InitForm(pMessageForm) 'restore form
      print($100) 'clear the screen (note that this erases teh graphics tiles too!)
      DrawForm
      pMessageForm:=0
    3:  'default option button handler
      clearOptions(byte[pOb+9])
      byte[pOb+7]:=true
      drawObject(pOb)
      drawMouse(true)  'because erased on redraw
    4:  'default check box button handler
      byte[pOb+7]:=NOT(byte[pOb+7])
      drawObject(pOb)
      drawMouse(true)  'because erased on redraw
    6:  'Charge menu button
      'set variable text
      str:=@strNotChecked
      if (byte[@frmCheck1+7])
        str:=@strChecked
      'change text before showing
      bytemove(@frmMultiText1+7+9,str,strsize(str)+1)
      str:=@strNotChecked
      if (byte[@frmCheck2+7])
        str:=@strChecked
      'change text before showing
      bytemove(@frmMultiText2+7+9,str,strsize(str)+1)

        'word[@frmMultiText1+6]:=(@@c1b)-@c1b
        '@@(word[@frmMultiText1+6])=@c1b
      
      showForm(@formCharge)
    10:  'Charge menu Done button
      showForm(@form1)


      
PRI clearOptions(group) |i,pob,itype,igroup
  'unselect all option buttons in given group
   repeat i from 1 to fObjects
     pob:= @@(word[fPointer+8+i*2])
     itype:=byte [pob]
     if (itype==4)
       igroup:=byte[pob+9]
       if (igroup==group)
         byte[pob+7]:=false
         drawObject(pob) 

PRI MessageBox(sMessTitle, sMessText)
  pMessageForm:=fPointer
  fPointer:=@msgbox'pForm:=@msgbox
  InitForm(fPointer)'pForm)'@msgbox)
  fStr:=sMessTitle
  DrawForm
  col:=fLeft+3
  row:=fTop+4
  color:=fTextColor
  print_string(sMessText)
  

PRI InitForm(pF)
  'get form window info 
  fTop:=byte [pF+0]
  fLeft:=byte[pF+1]
  fHeight:=byte[pF+2]  
  fWidth:=byte[pF+3]
  fStr:= @@(word[pF+4]) '@sTitle
  'get form object info and draw them
  fTitleColor:=0                                        'byte[pF+6]
  fBorderColor:=14                                                              'byte[pF+7]
  fTextColor:=1
  fDefaultButton:=byte[pF+8] 
  fObjects:=byte[pF+9]
  fPointer:=pF

PRI DrawForm|pObject, i
  'hide mouse
  drawmouse(false)
  'draw form
  DrawWindow'(fTop,fLeft,fHeight,fWidth, fStr,fTitleColor,fBorderColor , fTextColor)
  'show mouse
  drawmouse(true) 
  repeat i from 1 to fObjects
    pObject:= @@(word[fPointer+9+i*2])
    drawObject(pObject)

PRI drawObject(pObject)|str,i
    'get object index
    repeat i from 1 to fObjects
      if (@@(word[fPointer+9+i*2])==pObject)
        quit
        
    oTop:= fTop+byte[pObject+1]
    oLeft:=fLeft+byte[pObject+2]
    oHeight:=byte[pObject+3]
    oWidth:= byte[pObject+4]
    oColor:= byte[pObject+5]  'hotkey index for buttons
    oType:=byte [pObject]
    case oType
      1:  'draw button
        'if (i==fDefaultButton)
        '  oColor+=2
        drawButton(byte[pObject+7], pObject+8,(i==fDefaultButton),oColor)
      2:  'draw text
        drawMultiText(pObject+7)
      3:  'draw group box
        drawGroupBox(pObject+7)
      4:  'draw option button
        drawOptionButton(pObject+10, byte[pObject+7],(i==fDefaultButton),byte[pObject+8],true)
      5:   'draw check-box button
        drawOptionButton(pObject+9, byte[pObject+7],(i==fDefaultButton),byte[pObject+8],false)

             
PRI drawButton(txtColor,str,bDefault,iHot)|clr,left
  clr:=10 
  if (bDefault)
    clr+=2
  boxBorder(oTop, oLeft, oHeight, oWidth, clr)
  left:=drawCenteredText(oTop+1, oLeft, oWidth,  txtColor, str)
  if (iHot<>0)
    'highlight the hot key
     col:=left+iHot-1
     color:=txtColor+1
     print(byte[str+iHot-1])



PRI drawOptionButton(str, value,bDefault,iHot,bOption)
  'draw option button or check (depending on bOption)
  row:=oTop
  col:=oLeft
  color:=oColor
  if (bDefault)
    color++
  if bOption  
    if (value==0)
      print_string(@OptionOff)
    else
      print_string(@OptionOn)
  else
    if (value==0)
      print_string(@CheckOff)
    else
      print_string(@CheckOn)
  color:=oColor    
  print_string(str)
  if (iHot<>0)
    'highlight the hot key
     col:=oLeft+iHot-1+4
     color:=oColor+1
     print(byte[str+iHot-1])  
  

PRI drawGroupBox(str)
  'draw a group box
  boxBorder(oTop, oLeft, oHeight, oWidth, oColor)
  'draw any text using form's color
  color:=fTextColor
  col:=oLeft+2
  row:=oTop-1
  print(32)
  print_string(str)
  print(32)
  


PRI drawMultiText(str)
   color:=oColor 
   print_multiline(oLeft, oTop, oWidth, str)            


PRI DrawWindow
' draw a window
  'draw title bar
  boxFill(ftop,fleft,1,fwidth,fTitleColor)
  drawCenteredText(ftop,fleft,fwidth,fTitleColor,fStr)
  'fill in center
  boxFill(ftop+3,fleft+1,fheight-4,fwidth-2,1)
  'draw border
  boxBorder(ftop+2,fleft,fheight-2,fwidth,fBorderColor)',0,0)
  'draw shadow
  darkenShadow(ftop,fleft,fheight,fwidth)



  


PRI drawCenteredText(top,left,width,clr,str):colLeft
  row:=top
  color:=clr
  'draw centered text
  col := left + 1 +(width-1-STRSIZE(str))/2
  colLeft:=col
  print_string(str)    
      
PRI darkenShadow(top,left,height,width) |i,j
  'make a shadow of given box
  repeat i from top+2 to top+height step 2
    col:=left+width
    row:=i
    darkenChar
    darkenChar
  row:=top+height
  repeat i from left+2 to left+width+1
    col:=i
    darkenChar

PRI darkenChar
  'darken character at row, col
  darken(row,col)
  darken(row+1,col++)

PRI darken(ro,co)|i,j,k
  'darken current position by adding 16 to it's color
  i:=array.word[ro * cols + co]
  k:=i&$003F  'color index
  if (k<16)
    k+=16
    j:=((i>>6)<<6)+k
    array.word[ro * cols + co]:=j


    
PRI boxBorder(top, left, height, width, clr) |  bottom, right, x, y, i

' Draw a box border           
  color := clr 
  boxcolor := clr'8 + clr<<1 + up

  'width := right-left+1 'strsize(str)
  'height := bottom-top '2
  right:=left+width-1
  bottom:=top+height-1

  boxptr := top * cols + left
  boxchr($0)
  repeat i from 1 to width-2
    boxchr($C)
  boxchr($8)
  repeat i from 1 to height-2
    boxptr := (top + i) * cols + left
    boxchr($A)
    boxptr += width-2
    boxchr($B)
  boxptr := (top + height -1) * cols + left
  boxchr($1)
  repeat i from 1 to width-2
    boxchr($D)
  boxchr($9)

    
PRI boxText(top, left, height, width, clr, str)
  'draw text in given box
  color:=clr
  col := left -1 +(width-STRSIZE(str))/2
  row := top + (height-4)/2
  print_string(str)

PRI boxFill(top,left,height,width,clr)|i,j
  'fill a box with space characters
  color:=clr
  row:=top
  repeat i from top to top+height-1 step 2
    col:=left
    repeat j from col to left+width-1
      print(32)
    row+=2  
  

PRI textbox(top, left, bottom, right, clr, str)

PRI boxchr(c): i

  array.word[boxptr++] := $8000 + c << 6 + boxcolor


PRI nuchr(c, nucolor)    'prints a user defined 4-color character, 'c', with color index, 'nucolor' 

  array.word[row * cols + col] := user_charbase + (c<<6)  + nucolor

PRI print_multiline(x, y, width, str)| n, i, j, l
  n := byte[str]
  row := y
  col := x
  repeat i from 1 to n
    l := width  
    repeat while byte[str]
      print(byte[str++])
      l--
    repeat j from 1 to l
      print($20)
    row := y + i<<1
    col := x
    str++
  row := y
  col := x + width - 1
  print(" ")
  
  'array.word[x*cols + y + width - 1] := $230 + 1 << 10

PRI print_string(ptr)

  repeat while byte[ptr]
    print(byte[ptr++])
    

PRI print(c) | i, k

'' Print a character
''
''       $0D = new line
''  $20..$FF = character
''      $100 = clear screen
''      $101 = home
''      $108 = backspace
''$110..$11F = select color

  if (row>47) OR (col>63) 'bound output
    return

  case c
    $0D:                'return?
      newline
                                             
    $07..$FF:           'character?
      k := color << 1 + c & 1
      i := $8000 + (c & $FE) << 6 + k
      array.word[row * cols + col] := i
      array.word[(row + 1) * cols + col] := i | $40
      if ++col == cols
        newline

    $100:               'clear screen?
      wordfill(@array, spacetile, tiles)
      col := row := 0

    $101:               'home?
      col := row := 0

    $108:               'backspace?
      if col
        col--

    $110..$11F:         'select color?
      color := c & $F


PRI newline | i

  col := 0
  if (row += 2) == rows
    row -= 2
    'scroll lines
    repeat i from 0 to rows-3
      wordmove(@array.word[i*cols], @array.word[(i+2)*cols], cols)
    'clear new line
    wordfill(@array.word[(rows-2)*cols], spacetile, cols<<1)
      

DAT


OptionOn byte
        byte "(",15,")",32,0
OptionOff byte
        byte "(",32,")",32,0 
  
CheckOn byte
        byte "[",88,"]",32,0
CheckOff byte
        byte "[",32,"]",32,0   



  
vgacolors long

'0..1:  text color 0:  Title Text
  long $F004F004       'yellow on dk.blue       
  long $F0F00404
'2..3:  text color 1:  Button and Form Text 
  long $00A800A8       'black on grey   
  long $0000A8A8
'4..5:  text color 2:  Highlighted Button and Form Text      
  long $80A880A8       'med.red on grey   
  long $8080A8A8 
'6..7:  text color 3:  Extra Button and Form Text    
  long $00000000'00F800F8        'black on yellow
  long $00000000'0000F8F8 
'8..9:  text color 4:  Highlighted Extra Button and Form Text   
  long $00000000'FC54FC54       'white on dark gray
  long $00000000'FCFC5454 
'10:  graphics 0:  Button up graphics (just in case want to make button with title colors...)
  long $FC54A8A8         'gray  
'11:  graphics 1:  Button down graphics      
  long $54FCA8A8         'gray            (topleft,bottomright,highlight,body)
'12:  graphics 2:  Button up highlighted graphics
  long $FC54FFA8'  
'13:  graphics 3:  Button down highlighted graphics   
  long $54FCFFA8'
'14:  graphics 4:   Window border graphics  
  long $0404A8A8         'gray  
'15:  graphics 5:  Background graphics
  long $08A808A8         'dk blue on gray
'reserve some space
  long 7[48]  




button1 byte
        byte 1  'type 1=button
        byte  24  'top
        byte  3 'left
        byte 4  'height
        byte 14  'width
        byte 1 'hot-key 1-based index         
        byte 1  'on left up handler
        byte 1   'Text Color    'can only be 1 or 3 (1 is the form color)
        byte "Run Menu",0 

        

button2 byte
        byte 1  'type 1=button
        byte  24  'top
        byte  22 'left
        byte 4  'height
        byte 14  'width
        byte 8 'hot-key 1-based index
        byte 6   'on left up handler
        byte 1   'Text Color 
        byte "Charge Menu",0


frmMultiText byte
        byte 2  'type 2=text
        byte 6  'top
        byte 5  'left
        byte 4  'height  = 2*number of text lines
        byte 36  'width  = length of longest line
        byte 1  'color
        byte 0  'on left up handler
        byte 2,"Welcome to the Basic Window/Form",0, "demo for the Parallax Propeller",0       'multiline string

frmMultiText1 word
        byte 2  'type 2=text
        byte 6  'top
        byte 3  'left
        byte 2  'height  set equal to 2*number of text lines
        byte 24  'width
        byte 1  'color
        byte 0  'on left up handler
        byte 1,"Check1:  Is NOT Checked.",0
        
frmMultiText2 word
        byte 2  'type 2=text
        byte 8  'top
        byte 3  'left
        byte 2  'height  set equal to 2*number of text lines
        byte 24  'width
        byte 1  'color
        byte 0  'on left up handler
        byte 1,"Check2:  Is NOT Checked.",0

strChecked byte "is checked.",0
strNotChecked byte "is Not checked.",0

frmGroup byte
        byte 3  'type 3=group box
        byte 4  'top
        byte 4  'left
        byte 8  'height  
        byte 38  'width
        byte 11  'color
        byte 0   'on left up handler
        byte "Group Box",0        
               
sTitle  byte "Rapid Charger Control",0
form1   word
        byte  5  'top
        byte  8 'left
        byte 30  'height
        byte 45  'width
        word @sTitle
        byte 0  'unused  'title text color
        byte 14  'unused  'border graphics color
        byte 0  'default button (or check or option)                   'text color
        byte 8   'number of objects
        word @button1  'address of object 1
        word @button2  'address of object 2
        word @frmMultiText  'address of object 3
        word @frmGroup
        word @frmOption1
        word @frmOption2
        word @frmCheck1
        word @frmCheck2

sCharge byte "Charge Menu",0
formCharge   word
'@sTitle  'form info for form#1
        byte  10  'top
        byte  14 'left
        byte 20  'height
        byte 30  'width
        word @sCharge
        byte 0  'unused    
        byte 14  'unused 
        byte 0  'default button 
        byte 3   'number of objects
        word @buttonChargeDone  'address of object 1
        word @frmMultiText1
        word @frmMultiText2

buttonChargeDone byte
        byte 1  'type 1=button
        byte  12  'top
        byte  7 'left
        byte 4  'height
        byte 14  'width
        byte 1 'hot-key 1-based index   
        byte 10  'on left up handler
        byte 1   'Text Color
        byte "Done",0 

frmCheck1
        byte 5  'type 5=check button
        byte 16  'top
        byte 26  'left
        byte 2  'height  
        byte 12  'width     'length of text plus 4
        byte 1  'text color
        byte 4   'on left up handler
        byte 1   'value:
        byte 7 'hot-key 1-based index 
        byte "Check 1",0

frmCheck2
        byte 5  'type 5=check button
        byte 18  'top
        byte 26  'left
        byte 2  'height  
        byte 12  'width     'length of text plus 4
        byte 1  'text color
        byte 4   'on left up handler
        byte 1   'value:
        byte 1 'hot-key 1-based index 
        byte "Check 2",0
        
frmOption1
        byte 4  'type 4=option button
        byte 16  'top
        byte 6  'left
        byte 2  'height  
        byte 12  'width     'length of text plus 4
        byte 1  'text color
        byte 3   'on left up handler
        byte 1   'value:
        byte 1 'hot-key 1-based index   
        byte 1  'group:  use to optionally only allow 1 on
        byte "Option 1",0


frmOption2
        byte 4  'type 4=option button
        byte 18  'top
        byte 6  'left
        byte 2  'height  
        byte 12  'width
        byte 1  'text color
        byte 3   'on left up handler
        byte 0   'value:
        byte 8 'hot-key 1-based index   
        byte 1  'group:  use to optionally only allow 1 on
        byte "Option 2",0
        
        
msgbox   word           'forms need to be word aligned
'Message Box form info
        byte  10  'top
        byte  15 'left
        byte 14  'height
        byte 30  'width
        word @sTitle
        byte 0  'unused 'title color
        byte 14 'unused 'border color
        byte 0  'default button 'text color
        byte 1   'number of objects
        word @buttonMsgBoxOK  'address of OK button
        
msgboxTitle byte "Message:",0

buttonMsgBoxOK byte
        byte 1  'type 1=button
        byte  8  'top
        byte  10 'left
        byte 4  'height
        byte 8  'width
        byte 1   'hot-key 1-based index 
        byte 2   'on left up handler
        byte 1   'Text Color
        byte "OK",0  


     
        

padding LONG  7[16] 'alignment padding for the following user defined characters     
uchar
        LONG  %%1100_1100_1100_1111         'new character 0
        LONG  %%1100_1100_1100_1111
        LONG  %%0011_0011_0011_0011
        LONG  %%0011_0011_0011_0011
        LONG  %%1100_1100_1100_1111         
        LONG  %%1100_1100_1100_1111
        LONG  %%0011_0011_0011_0011
        LONG  %%0011_0011_0011_0011
        LONG  %%1100_1100_1100_1111         
        LONG  %%1100_1100_1100_1111
        LONG  %%0011_0011_0011_0011
        LONG  %%0011_0011_0011_0011
        LONG  %%1100_1100_1100_1111         
        LONG  %%1100_1100_1100_1111
        LONG  %%0011_0011_0011_0011
        LONG  %%0011_0011_0011_0011
        


  